package main

import "fmt"

func main() {
	var myMap1 map[string]string
	if myMap1 == nil {
		fmt.Println("myMap1是一个空map")
	}
	myMap1 = make(map[string]string, 10)
	myMap1["one"] = "java"
	myMap1["two"] = "c++"
	myMap1["three"] = "php"
	fmt.Println(myMap1)

	myMap2 := make(map[string]string)
	myMap2["one"] = "apple"
	myMap2["two"] = "orange"
	myMap2["three"] = "banana"
	fmt.Println(myMap2)

	myMap3 := map[string]string{
		"one":   "php",
		"two":   "golang",
		"three": "lua",
	}
	fmt.Println(myMap3)

	cityMap := make(map[string]string)
	cityMap["China"] = "Beijing"
	cityMap["Japan"] = "Tokyo"
	cityMap["USA"] = "New York"
	// 遍历
	for key, value := range cityMap {
		fmt.Printf("key = %s, value = %s\n", key, value)
	}
	// 删除
	delete(cityMap, "Japan")
	// 修改
	cityMap["USA"] = "Shenyang"
	for key, value := range cityMap {
		fmt.Println("key = ", key, ", value = ", value)
	}
	changeValue(cityMap)
	printMap(cityMap)
}

func printMap(cityMap map[string]string) {
	for key, value := range cityMap {
		fmt.Println("key = ", key, ", value = ", value)
	}
}

func changeValue(cityMap map[string]string) {
	cityMap["England"] = "London"
}
